#ifndef CAMERA_DRIVING_PERCEPTION_FOUR_GENERAL_WRAPPER_HEADER_H
#define CAMERA_DRIVING_PERCEPTION_FOUR_GENERAL_WRAPPER_HEADER_H
#include "sub/SubWrapperHelper.h"
#include "sub/SubDataWrapper.h"
#include "CameraDrivingPerceptionFour_SubDataWrapper.h"
#include "camera_driving_perception_four/executable.h"
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "CameraDrivingPerceptionFour_PubDataWrapper.h"


using namespace jac::ap::cameradrivingservice::proxy;
using namespace jac::ap::cameradrivingperservice::skeleton;
using namespace jac::ap::canservice::proxy;
using namespace jac::ap::slamservice::proxy;
using namespace jac::ap::vedservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(CamDrvPerceptionFour2Fusion_Provide, CamDrvPerceptionFour2Fusion_PubDataWrapper, CameraDrivingPerceptionServiceSkeleton, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent);
//SubWrappers
GENERATE_SUB_WRAPPER(CamDrv2CamDrvPerceptionFour_Required, CamDrv2CamDrvPerceptionFour_SubDataWrapper, CameraDrivingServiceProxy, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionFourEvent, "16", 10);
GENERATE_SUB_WRAPPER(Slam2DrvPerceptionFourOdom_Required, Slam2DrvPerceptionFourOdom_SubDataWrapper, SLAMServiceProxy, dpc::slam_odometry, SLAMOdometryEvent, "8", 10);
GENERATE_SUB_WRAPPER(CAN2DrvPerceptionFour_Required, CAN2DrvPerceptionFour_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);
GENERATE_SUB_WRAPPER(VED2DrvPerceptionFour_Required, VED2DrvPerceptionFour_SubDataWrapper, VEDServiceProxy, dpc::VED4FusionEgoMotion, VED2FusionEgoMotionEvent, "11", 10);

class GeneralWrapper {
public:
    //Provides
    CamDrvPerceptionFour2Fusion_Provide _CamDrvPerceptionFour2Fusion_Provide;
    //Requireds
    CamDrv2CamDrvPerceptionFour_Required _CamDrv2CamDrvPerceptionFour_Required;
    Slam2DrvPerceptionFourOdom_Required _Slam2DrvPerceptionFourOdom_Required;
    CAN2DrvPerceptionFour_Required _CAN2DrvPerceptionFour_Required;
    VED2DrvPerceptionFour_Required _VED2DrvPerceptionFour_Required;
    
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
    void Start();
};


#endif
